<?php

/**
 * Prestashop module for Oct8ne
 *
 * @category  Prestashop
 * @category  Module
 * @author    Prestaquality.com
 * @copyright 2016 Prestaquality
 * @license   Commercial license see license.txt
 * Support by mail  : info@prestaquality.com
 */

require_once dirname(__FILE__) . '/AbstractSearchEngine.php';

/**
 * Implementacion especifica de doofinder
 * Class OctDoofinderSearch
 */
class OctMotiveSearch extends AbstractSearchEngine
{

    function doSearch($language, $search, $page, $pageSize, $orderBy, $dir)
    {
        $iso_code = Language::getIsoById($language);
        $searchIdInDB = false;
        $curl = curl_init();
        $endpoint = Configuration::get(Oct8ne::$URL_API_MOTIVESEARCH);
        $tenantId = Configuration::get(Oct8ne::$TENANT_MOTIVESEARCH);

        $search = urlencode($search);
        // Get url
        $url = $endpoint.'?query='.$search;
        
        // Get start and row parameter. Set them if there are not found, otherwise let it be
        $parts = parse_url($url);
        parse_str($parts['query'], $query);

        if ( !isset( $query['start'] )) {
            $url = $url.'&start='.($page - 1);            
        }
        if ( !isset( $query['rows'] ) ) $url = $url.'&rows=95';

        $headers = array("x-engine-id: ".$tenantId);
        
        // Execute curl
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);

        $output = curl_exec($curl);

        // Check the return value of curl_exec()
        if ($output === false) {
            throw new Exception(curl_error($curl), curl_errno($curl));
        }
        curl_close($curl);

        $result = Tools::jsonDecode($output);

        $total = (int)$result->pagination->total;
        $products = array();
        if (is_array($result->hits->docs) && count($result->hits->docs) > 0) {
            foreach ($result->hits->docs as $item) {
                if($searchIdInDB){
                    $query = new DbQuery();
                    $query->select('p.id_product');
                    $query->from('product', 'p');
                    $query->where('p.reference = \''.pSQL($item->id).'\'');

                    $id_product = (int)Db::getInstance(_PS_USE_SQL_SLAVE_)->getValue($query);

                    if (!empty($id_product)) {
                        $product = array(
                            'id_product' => $id_product
                        );

                        $products[] = $product;
                    }
                }else{
                    if (!empty($item->id)) {
                        $product = array(
                            'id_product' => $item->id
                        );

                        $products[] = $product;
                    }
                }
            }
        }

        return array(
            'total' => $total,
            'result' => $products
        );
    }
}